unit fmDropMasterTest;

{ Example application for DropMaster.

  Demonstrates various techniques in the use of TDMTextSource, TDMTextTarget,
  TDMGraphicSource, TDMGraphicTarget.

  The main point here:  see how little code is needed.  Most of the code here
  was written by Delphi!  And the portion that was manually coded is mainly
  for user-interface purposes.

  Last modified:  12/24/2011}

interface

uses
  Windows, Types, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Buttons, Grids, ExtCtrls, DMComps;

type
  TForm1 = class(TForm)
    pnlButtons: TPanel;
    Panel1: TPanel;
    btnClose: TButton;
    Panel2: TPanel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    DMTextSource1: TDMTextSource;
    DMTextTarget1: TDMTextTarget;
    ListBox1: TListBox;
    StaticText1: TStaticText;
    DMTextTarget2: TDMTextTarget;
    DMTextSource2: TDMTextSource;
    DMTextSource3: TDMTextSource;
    Memo1: TMemo;
    TabSheet3: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    ListBox2: TListBox;
    Label3: TLabel;
    CheckBox2: TCheckBox;
    Label4: TLabel;
    CheckBox1: TCheckBox;
    Label5: TLabel;
    Label6: TLabel;
    ListBox3: TListBox;
    CheckBox3: TCheckBox;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    TabSheet4: TTabSheet;
    TreeView1: TTreeView;
    Label10: TLabel;
    ListView1: TListView;
    Label11: TLabel;
    Label12: TLabel;
    DMTextSource4: TDMTextSource;
    Label13: TLabel;
    Label14: TLabel;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    RadioGroup1: TRadioGroup;
    Label24: TLabel;
    TabSheet6: TTabSheet;
    DMGraphicTarget1: TDMGraphicTarget;
    Panel5: TPanel;
    Label25: TLabel;
    TabSheet7: TTabSheet;
    Label26: TLabel;
    Label27: TLabel;
    Image2: TImage;
    DMGraphicSource1: TDMGraphicSource;
    Label28: TLabel;
    Label29: TLabel;
    Image3: TImage;
    Label30: TLabel;
    CheckBox6: TCheckBox;
    Label31: TLabel;
    DMGraphicSource2: TDMGraphicSource;
    RadioGroup2: TRadioGroup;
    CheckBox7: TCheckBox;
    DMGraphicSource3: TDMGraphicSource;
    CheckBox8: TCheckBox;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    Panel6: TPanel;
    DMGraphicSource4: TDMGraphicSource;
    CheckBox9: TCheckBox;
    CheckBox10: TCheckBox;
    CheckBox11: TCheckBox;
    Panel7: TPanel;
    Label21: TLabel;
    procedure DMTextTarget1Drop(Sender: TObject; Acceptor: TWinControl;
      const dropText: String; X, Y: integer);
    procedure btnCloseClick(Sender: TObject);
    procedure DMTextSource2BeforeDrop(Sender: TObject; Donor: TComponent;
      var dropText: String; var cancelDrop: Boolean);
    procedure DMTextSource2AfterDrop(Sender: TObject; Donor: TComponent;
      droppedOK: Boolean);
    procedure DMTextTarget2Drop(Sender: TObject; Acceptor: TWinControl;
      const dropText: String; X, Y: integer);
    procedure DMTextSource4AfterDrop(Sender: TObject; Donor: TComponent;
      droppedOK: Boolean);
    procedure CheckBox4Click(Sender: TObject);
    procedure DMTextSource3AfterDrop(Sender: TObject; Donor: TComponent;
      droppedOK: Boolean);
    procedure DMTextSource3BeforeDrop(Sender: TObject; Donor: TComponent;
      var dropText: String; var cancelDrop: Boolean);
    procedure RadioGroup1Click(Sender: TObject);
    procedure DMTextTarget1DragEnter(Sender: TObject;
      effect: TDropEffect; X, Y: Integer);
    procedure DMTextTarget1DragLeave(Sender: TObject);
    procedure DMTextTarget1DragOver(Sender: TObject; effect: TDropEffect;
      X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure DMGraphicTarget1Drop(Sender: TObject; Acceptor: TWinControl;
      thePicture: TPicture; X, Y: Integer);
    procedure CheckBox6Click(Sender: TObject);
    procedure RadioGroup2Click(Sender: TObject);
    procedure CheckBox7Click(Sender: TObject);
    procedure CheckBox9Click(Sender: TObject);
    procedure CheckBox10Click(Sender: TObject);
    procedure CheckBox11Click(Sender: TObject);
    procedure ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ListBox2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TreeView1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ListView1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel6MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
    saveAcceptGraphicFormats: TDropGraphicFormats;

    procedure updateAcceptGraphicFormats;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  TypInfo;

procedure TForm1.ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
// Detect the start of a drag for ListBox1, and begin the drag operation.
begin
  if DragDetect(ListBox1.Handle, POINT(X,Y)) then
    DMTextSource1.Execute;
end;

procedure TForm1.ListBox2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
// Detect the start of a drag for ListBox2, and begin the drag operation.
begin
  if DragDetect(ListBox2.Handle, POINT(X,Y)) then
    DMTextSource2.Execute;
end;

procedure TForm1.DMTextTarget1Drop(Sender: TObject; Acceptor: TWinControl;
  const dropText: String; X, Y: integer);
// Handle drops on memo1.  Notify the user whether files or just non-file text
// has been dropped.

begin
  label24.caption := Format('%s: (%d,%d)', ['Drop', X, Y]);

  if ((Sender as TDMTextTarget).DroppedTextFormat = dtfFiles) then
    label24.caption := label24.caption + ' [files]'
  else
    label24.caption := label24.caption + ' [text]';

  // If this is a URL, the actual URL address is in dropText
  // (also in droppedLines[0] and Text).  The title is in URLTitle.
  if ((Sender as TDMTextTarget).DroppedTextFormat = dtfURL) then
    label24.caption := label24.caption
      + Format(' [URL, title=%s]', [(Sender as TDMTextTarget).URLTitle]);

  // The only REQUIRED part of this handler.  Do something with the text
  // that was just dropped.  If this is missing, the drop won't do anything.
  // You have to decide what you want to do with the text you get!
  memo1.lines.add(dropText);
  // The following line is equivalent to the preceding line.
  // memo1.lines.add((Sender as TDMTextTarget).Text);

end;

procedure TForm1.btnCloseClick(Sender: TObject);
// Close down
begin
  Application.Terminate;
end;

procedure TForm1.DMTextSource2BeforeDrop(Sender: TObject;
  Donor: TComponent; var dropText: String; var cancelDrop: Boolean);
// Called before the drop of text from DMTextSource2.  Allow the
// user to cancel.  You can modify dropText here if you want.
//
// This handler is shared by DMTextSource1 and DMTextSource2.  The particular
// one in question is identified by looking at Sender.
var
  aString: string;
  showConfirmation: boolean;
begin
  showConfirmation := ((Sender = DMTextSource1) and (CheckBox1.Checked))
    or ((Sender = DMTextSource2) and (CheckBox2.Checked));
  if showConfirmation then
  begin
    if (deMove = (Sender as TDMTextSource).ReturnedEffect) then
      aString := 'Do you really want to move the string "%s"?'
    else
      aString := 'Do you really want to copy the string "%s"?';

    aString := Format(aString, [dropText]);

    cancelDrop := (MessageDlg(aString, mtConfirmation, [mbYes, mbNo], 0) = mrNo);
  end;
end;

procedure TForm1.DMTextSource2AfterDrop(Sender: TObject; Donor: TComponent;
  droppedOK: Boolean);
var
  j: integer;
begin
  // A drop has been done from DMTextSource2.  If the drop was a move, we
  // have to remove the text from ListBox2.  You have to make sure that
  // droppedOK is true;  if you end the drag while the "no drag" cursor is
  // showing, this event will still fire, but with droppedOK = false.
  //
  // In this handler, the expressions (Sender as TDMTextSource).DonorComponent,
  // Donor, and ListBox2 all refer to the same thing.

  if droppedOK then
  begin
    if (deMove = (Sender as TDMTextSource).ReturnedEffect) then
    begin
      // It's a move.  Delete from the top down to avoid messing
      // up the Selected[] property.
      for j := ListBox2.items.count downTo 1 do    // Iterate
      begin
        if ListBox2.Selected[j-1] then
          ListBox2.items.delete(j-1);
      end;    // for
    end;

  end;
end;

procedure TForm1.DMTextTarget2Drop(Sender: TObject; Acceptor: TWinControl;
  const dropText: String; X, Y: integer);
// Handle drops on ListBox3
//var
//  j: integer;
///  aSL: TStringList;
begin
  // Bring the form to the top, so that the message dialog won't accidentally
  // be hidden.
  SetForegroundWindow(Handle);

  if CheckBox3.Checked and
    (MessageDlg('Do you want to clear the list before dropping?', mtConfirmation,
      [mbYes, mbNo], 0) = mrYes) then
    ListBox3.Items.Clear;

  // Show a sign that files were dropped (rather than text)
  Label7.visible := ((Sender as TDMTextTarget).DroppedTextFormat = dtfFiles);

  // Handle the drop.  Show the coordinates, just for fun.
  ListBox3.Items.Add(Format('      Drop at client pos (%d,%d):', [X, Y]));
  ListBox3.Items.AddStrings((Sender as TDMTextTarget).DroppedLines);

  // The following is equivalent to the preceding line, i.e., DroppedLines
  // and dropText contain the same information.
  //aSL := TStringList.create;
  //try
  //  // Get the dropped text into dropText
  //  aSL.text := dropText;
  //  for j := 1 to aSL.count do    // Iterate
  //  begin
  //    ListBox3.Items.Add(aSL[j-1]);
  //  end;    // for
  //finally
  //  aSL.free;
  //end;

end;

procedure TForm1.TreeView1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
// Detect the start of a drag for TreeView1, and begin the drag operation.
begin
  if DragDetect(TreeView1.Handle, POINT(X,Y)) then
  begin
    // For the explanation of the following line, see DMTextSource3BeforeDrop
    DMTextSource3.DonorComponent := TreeView1;

    DMTextSource3.Execute;
  end;

end;

procedure TForm1.ListView1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
// Detect the start of a drag for ListView1, and begin the drag operation.
begin
  if DragDetect(ListView1.Handle, POINT(X,Y)) then
    DMTextSource4.Execute;
end;

procedure TForm1.DMTextSource4AfterDrop(Sender: TObject; Donor: TComponent;
  droppedOK: Boolean);
var
  aLi, bLi: TListItem;
begin
  // A drop has been done from DMTextSource4.  If the drop was a move, we
  // have to remove the selections from ListView1.  You have to make sure that
  // droppedOK is true;  if you end the drag while the "no drag" cursor is
  // showing, this event will still fire, but with droppedOK = false.
  // This allows you to clean up or reset something on such an operation.

  if droppedOK then
  begin
    if (deMove = (Sender as TDMTextSource).ReturnedEffect) then
    begin
      // It's a move.  Delete the selected ones.
      // Loop over the selected members of the TListView items
      with (Donor as TListView) do
      begin
        Items.BeginUpdate; // Efficiency

        aLi := Selected;
        while assigned(GetNextItem(aLi, sdAll, [isSelected])) do
        begin
          bLi := aLi;
          aLi := GetNextItem(aLi, sdAll, [isSelected]);
          // We know it's assigned - look at the while statement above...
          bLi.delete;
        end;    // while
        // There's one left - delete it
        aLi.delete;

        Items.EndUpdate; // Efficiency
      end;    // with
    end;
  end;

end;

procedure TForm1.CheckBox4Click(Sender: TObject);
begin
  ListView1.Multiselect := CheckBox4.checked;
end;

procedure TForm1.DMTextSource3AfterDrop(Sender: TObject; Donor: TComponent;
  droppedOK: Boolean);
begin
  // A drop has been done from DMTextSource3.  If the drop was a move, we
  // have to remove the selections from TreeView1.  You have to make sure that
  // droppedOK is true;  if you end the drag while the "no drag" cursor is
  // showing, this event will still fire, but with droppedOK = false.
  //
  // We'll explicitly refer to TreeView1 rather than (Donor as TreeView)
  // for reasons explained in DMTextSource3BeforeDrop.

  if droppedOK then
  begin
    if (deMove = (Sender as TDMTextSource).ReturnedEffect) then
    begin
      // It's a move.  Delete the selected ones
      with TreeView1 do
      begin
        if assigned(Selected) then
          Selected.Delete;
      end;    // with
    end;
  end;

end;

procedure TForm1.DMTextSource3BeforeDrop(Sender: TObject;
  Donor: TComponent; var dropText: String; var cancelDrop: Boolean);
// We're about to get a drop from the tree view.  If the checkbox is
// checked, we're going to pass the complete path to the selected node
// as opposed to the node's title alone.  Otherwise, we do nothing.
//
// NB - modifying the dropText when we have a DonorComponent will disconnect
// the DonorComponent.  For this reason, we reassign it explicily just before
// the Execute call in TreeView1MouseDown.
const
  separator = '\'; // Separate nodes with this
var
  aTn: TTreeNode;
begin
  // Bale out if the checkbox is not checked.
  if not CheckBox5.checked then exit;

  with (Donor as TTreeView) do
  begin

    aTn := Selected;

    // Now, build it from the node toward the root
    dropText := aTn.Text;
    while (aTn.Parent <> nil) do
    begin
      dropText := aTn.Parent.Text + separator + dropText;
      aTn := aTn.Parent;
    end;    // while
  end;    // with

  // Put a header on it
  dropText := separator + separator + dropText;

end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  ListView1.ViewStyle := TViewStyle(RadioGroup1.ItemIndex);
end;

procedure TForm1.DMTextTarget1DragEnter(Sender: TObject;
  effect: TDropEffect; X, Y: Integer);
// Handle drag enter for DMTextTarget1
begin
  label24.caption := Format('%s: (%d,%d) %s', ['Enter', X, Y, stringFromDropEffects([effect])]);
end;

procedure TForm1.DMTextTarget1DragLeave(Sender: TObject);
// Handle drag leave for DMTextTarget1
begin
  label24.caption := 'Leave';
end;

procedure TForm1.DMTextTarget1DragOver(Sender: TObject;
  effect: TDropEffect; X, Y: Integer);
// Handle drag over for DMTextTarget1
begin
  label24.caption := Format('%s: (%d,%d) %s', ['Over', X, Y, stringFromDropEffects([effect])]);
  // "effect" in the preceding could be replaced by
  // "(Sender as TDMTextTarget).DropEffect"
end;

procedure TForm1.FormCreate(Sender: TObject);
// Set up at form creation time
var
  i, j: integer;
begin
  PageControl1.ActivePage := Self.TabSheet7;
  // When the form loads, make sure the page with the pretty pictures is showing

  // Save the design-time state of the acceptable graphic formats
  // This is only for UI convenience later in implementing "Preferred only"
  saveAcceptGraphicFormats := DMGraphicTarget1.AcceptGraphicFormats;

  // Set various controls in the correct state
  RadioGroup2.itemIndex := integer(DMGraphicTarget1.PreferredFormat);

  with DMGraphicTarget1 do
  begin
    // Is the preferred format the only one?
    CheckBox7.Checked := [PreferredFormat] = AcceptGraphicFormats;
  end;    // with
  
  CheckBox9.checked := DMTextTarget1.AcceptIEHTML;
  CheckBox10.Checked := DMTextTarget2.AcceptFiles;
  CheckBox11.Checked := DMTextTarget1.AcceptRichText;
  // Preceding 2 lines are equivalent to the (more cumbersome)
  // CheckBox9.checked := (atIEHTML in DMTextTarget1.AcceptTextFormats);
  // CheckBox10.checked := (atFiles in DMTextTarget2.AcceptTextFormats);

  // Opening a D4 project in D3 messes up the TListView contents, so we
  // set some listview contents manually to avoid this.  This is only to allow
  // us to use the same example .DFM in both D3 and D4, without worrying about
  // losing the contents by opening in D4.
  with ListView1 do
  begin
    // Add 4 items
    for i := 1 to 4 do
    begin
      with Items.add do
      begin
        caption := Format('Item %d,1', [i]);;
        with subItems do
        begin
          for j := 2 to 4 do
          begin
            add(Format('Item %d,%d', [i, j]));
          end;
        end;
      end;
    end;
    // Try one with blanks
    with Items.add do
    begin
      caption := 'One more';
      with subItems do
      begin
        add('');
        add('testing');
      end;
    end;
  end;
end;

procedure TForm1.DMGraphicTarget1Drop(Sender: TObject;
  Acceptor: TWinControl; thePicture: TPicture; X, Y: Integer);
var
  aString: string;
begin
  if assigned(thePicture) then
  begin
    // Give the picture to the TImage.  The following 2 lines are equivalent.
    // image1.picture := (Sender as TDMGraphicTarget).Picture;
    image1.picture := thePicture;

    // Optionally stretch depending on checkbox.
    image1.stretch := CheckBox6.checked;

    // Show in the label what kind of object got dropped
    //aString := Image1.picture.graphic.ClassName;
    //Delete(aString, 1, 1);  // Drop the leading "T"
    // Following is an alternative for the preceding 2 lines
    case (Sender as TDMGraphicTarget).DroppedGraphicFormat of
      dgfBitmap: aString := 'Bitmap';
      dgfMetafile: aString := 'Metafile';
    else
      aString := '???'; // Should never happen!
    end;
    label31.caption := 'Dropped a '+ aString;
  end;
end;

procedure TForm1.CheckBox6Click(Sender: TObject);
begin
  with Image1 do
  begin
    // If the image is empty, don't do anything
    if not ((Picture.width=0) and (Picture.height=0)) then
    begin
      Stretch := CheckBox6.checked; // Are we stretching?
      // Image1.AutoSize and ScrollBox1.AutoScroll need to match
      AutoSize := not Stretch;
      ScrollBox1.AutoScroll := not Stretch;

      if Stretch then
        // Stretching, so reset the image to match the scrollbox bounds
        SetBounds(ScrollBox1.left, ScrollBox1.top, ScrollBox1.width, ScrollBox1.height);
    end;
  end;
end;

procedure TForm1.Image2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
// Detect the start of a drag for Image2, and begin the drag operation.
begin
  if DragDetect(Handle, POINT(X,Y)) then
    DMGraphicSource1.Execute;
end;

procedure TForm1.Image3MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
// Detect the start of a drag for Image3, and begin the drag operation.
begin
  if DragDetect(Handle, POINT(X,Y)) then
    DMGraphicSource2.Execute;
end;

procedure TForm1.RadioGroup2Click(Sender: TObject);
begin
  // Choose a new preferred format
  DMGraphicTarget1.PreferredFormat := TDropGraphicFormat(RadioGroup2.itemIndex);

  // And make sure the acceptible formats are updated as a result
  updateAcceptGraphicFormats;
end;

procedure TForm1.updateAcceptGraphicFormats;
// After a change in the preferred format, or in whether the preferred format
// alone is acceptable, update the acceptable formats.
begin
  with DMGraphicTarget1 do
  begin
    if CheckBox7.Checked then
      // Preferred only - i.e., use the preferred one if it intersects with the
      // design-time acceptable graphic formats (set intersection)
      AcceptGraphicFormats := [PreferredFormat]*saveAcceptGraphicFormats
    else
      // Not preferred only - take the design-time defaults
      AcceptGraphicFormats := saveAcceptGraphicFormats;
  end;    // with
end;

procedure TForm1.CheckBox7Click(Sender: TObject);
begin
  updateAcceptGraphicFormats;
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
// Detect the start of a drag for Image1, and begin the drag operation.
begin
  // If we're allowed, do a drag from this image
  if CheckBox8.checked then
    if DragDetect(handle, POINT(X,Y)) then
      DMGraphicSource3.Execute;
end;

procedure TForm1.Panel6MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
// Detect the start of a drag for Panel6, and begin the drag operation.
begin
  // No DonorImage this time.  Just get the image of the form's client area
  // into the Picture property, and execute the graphic source.
  // See how easy this is?
  if DragDetect(Panel6.Handle, POINT(X,Y)) then
  begin
    DMGraphicSource4.Picture.Bitmap := GetFormImage;
    DMGraphicSource4.Execute;
  end;

end;

procedure TForm1.CheckBox9Click(Sender: TObject);
// Handle checkbox click for accepting IEHTML format
begin
  DMTextTarget1.AcceptIEHTML := CheckBox9.Checked;

  // Preceding is equivalent to the (more cumbersome)
  // if CheckBox9.Checked then
  //   DMTextTarget1.AcceptTextFormats := DMTextTarget1.AcceptTextFormats + [atIEHTML]
  // else
  //   DMTextTarget1.AcceptTextFormats := DMTextTarget1.AcceptTextFormats - [atIEHTML];
end;

procedure TForm1.CheckBox10Click(Sender: TObject);
// Demonstrate dynamic change in accept formats.
begin
  DMTextTarget2.AcceptFiles := CheckBox10.Checked;

  // Preceding is equivalent to manipulating DMTextTarget2.AcceptTextFormats
  // (see CheckBox9Click method immediately above)
  // and is one of several Accept* public properties on the target
  // components provided for convenience.
end;

procedure TForm1.CheckBox11Click(Sender: TObject);
// Handle checkbox click for accepting RTF
begin
  DMTextTarget1.AcceptRichText := CheckBox11.Checked;
end;

end.
